-- written by DaddelZeit
-- DO NOT USE WITHOUT PERMISSION

local M = {}

local maxEmissionL = 0
local maxEmissionR = 0

local matL
local matR

local function updateEmission(emissionScaleL, emissionScaleR)
    local newEmissionL = maxEmissionL * emissionScaleL
    local newEmissionR = maxEmissionR * emissionScaleR

    matL:setField("emissiveFactor", 0, newEmissionL.." "..newEmissionL.." "..newEmissionL)
    matL:flush()
    matL:reload()
    matR:setField("emissiveFactor", 0, newEmissionR.." "..newEmissionR.." "..newEmissionR)
    matR:flush()
    matR:reload()
end

local function initEmissionEdit(newMatNameL, newMatNameR)
    if not matL and not matR then
        if newMatNameL then matL = scenetree.findObject(newMatNameL) else M.updateEmission = nop return end
        if newMatNameR then matR = scenetree.findObject(newMatNameR) else M.updateEmission = nop return end

        maxEmissionL = matL.emissiveFactor.x
        maxEmissionR = matR.emissiveFactor.x

        if not maxEmissionL or not maxEmissionR then
            M.updateEmission = nop
            return
        end
    end
end

local function reset()
    matL = nil
    matR = nil
end

local function onExtensionLoaded()
end

M.updateEmission = updateEmission
M.initEmissionEdit = initEmissionEdit
M.onExtensionLoaded = onExtensionLoaded
M.reset = reset

return M