-- written by DaddelZeit
-- DO NOT USE WITHOUT PERMISSION

local M = {}

local leftIsOn = false
local rightIsOn = false

local corneringDataL = {}
local corneringDataR = {}

local corneringSmootherL = newExponentialSmoothingT(30)
local corneringSmootherR = newExponentialSmoothingT(30)

local allowFade -- PERFORMANCE
local fadeTimer = 2 -- to update every 2nd frame
local fadeValR = 0
local fadeValL = 0
local lastFadeValL = 0
local lastFadeValR = 0

local glowMapEdit = false
local geExtensionName
local glowMapEditInit = false

local function updateGFX(dt)
    if playerInfo.anyPlayerSeated then -- breaks stuff otherwise, we also dont need it on ai anyway
        if electrics.values.fog == 0 then
            if ((electrics.values.wheelspeed > 13.4 and electrics.values.wheelspeed < 0.1) and (electrics.values.signal_left_input == 0 and electrics.values.signal_right_input == 0)) or electrics.values.lowhighbeam == 0 then
                leftIsOn = false
                rightIsOn = false
            else
                rightIsOn = electrics.values.steering < -70 or (electrics.values.signal_right_input == 1 and electrics.values.wheelspeed < 8.333 and electrics.values.hazard_enabled == 0)
                leftIsOn = electrics.values.steering > 70 or (electrics.values.signal_left_input == 1 and electrics.values.wheelspeed < 8.333 and electrics.values.hazard_enabled == 0)
            end
        else
            leftIsOn = true
            rightIsOn = true
        end

        if allowFade then
            fadeValL = corneringSmootherL:get(leftIsOn and 1 or 0)
            fadeValR = corneringSmootherR:get(rightIsOn and 1 or 0)

            if fadeValL < 0.05 then fadeValL = 0 elseif fadeValL > 0.95 then fadeValL = 1 end
            if fadeValR < 0.05 then fadeValR = 0 elseif fadeValR > 0.95 then fadeValR = 1 end
            electrics.values.cornering_L = (fadeValL > 0.05 and electrics.values.ignitionLevel > 0)
            electrics.values.cornering_R = (fadeValR > 0.05 and electrics.values.ignitionLevel > 0)

            if fadeTimer >= 2 and (lastFadeValL ~= fadeValL or lastFadeValR ~= fadeValR) then
                if corneringDataL.propIndex and corneringDataR.propIndex then
                    obj:queueGameEngineLua(
                        " be:getPlayerVehicle(0):getProp("..corneringDataL.propIndex.."):getLight():setLightArgs("
                        ..corneringDataL.innerAngle..", "
                        ..corneringDataL.outerAngle..", "
                        ..((fadeValL*corneringDataL.maxBrightness)/100)..", "
                        ..corneringDataL.range..", "
                        .."ColorF("..corneringDataL.color.r..","..corneringDataL.color.g..","..corneringDataL.color.b..","..corneringDataL.color.a.."), "
                        .."vec3("..corneringDataL.attenuation.x..","..corneringDataL.attenuation.y..","..corneringDataL.attenuation.y.."), "
                        ..corneringDataL.castShadows..") "

                        ..

                        " be:getPlayerVehicle(0):getProp("..corneringDataR.propIndex.."):getLight():setLightArgs("
                        ..corneringDataR.innerAngle..", "
                        ..corneringDataR.outerAngle..", "
                        ..((fadeValR*corneringDataR.maxBrightness)/100)..", "
                        ..corneringDataR.range..", "
                        .."ColorF("..corneringDataR.color.r..","..corneringDataR.color.g..","..corneringDataR.color.b..","..corneringDataR.color.a.."), "
                        .."vec3("..corneringDataR.attenuation.x..","..corneringDataR.attenuation.y..","..corneringDataR.attenuation.y.."), "
                        ..corneringDataR.castShadows..") "
                    )
                end

                if geExtensionName and glowMapEdit and glowMapEditInit then
                    obj:queueGameEngineLua(
                        " extensions."..geExtensionName..".updateEmission("..fadeValL..", "..fadeValR..")"
                    )
                end

                fadeTimer = 0
            end

            lastFadeValL = fadeValL
            lastFadeValR = fadeValR
            fadeTimer = fadeTimer + 1
        else
            electrics.values.cornering_L = ((leftIsOn and electrics.values.ignitionLevel > 0) and 1 or 0)
            electrics.values.cornering_R = ((rightIsOn and electrics.values.ignitionLevel > 0) and 1 or 0)
        end
    end
end

local function init(jbeamData)
    allowFade = jbeamData.allowFade

    if allowFade then
        for _,v in pairs(v.data.props) do
            if v.mesh == "SPOTLIGHT" then
                if v.func == "cornering_L" then
                    corneringDataL.propIndex = v.cid
                    corneringDataL.maxBrightness = v.lightBrightness
                    corneringDataL.innerAngle = v.lightInnerAngle
                    corneringDataL.outerAngle = v.lightOuterAngle
                    corneringDataL.range = v.lightRange
                    corneringDataL.color = v.lightColor
                    corneringDataL.attenuation = vec3(v.lightAttenuation)
                    corneringDataL.castShadows = tostring(v.lightCastShadows)
                elseif v.func == "cornering_R" then
                    corneringDataR.propIndex = v.cid
                    corneringDataR.maxBrightness = v.lightBrightness
                    corneringDataR.innerAngle = v.lightInnerAngle
                    corneringDataR.outerAngle = v.lightOuterAngle
                    corneringDataR.range = v.lightRange
                    corneringDataR.color = v.lightColor
                    corneringDataR.attenuation = vec3(v.lightAttenuation)
                    corneringDataR.castShadows = tostring(v.lightCastShadows)
                end
            end
        end
    end

    leftIsOn = false
    rightIsOn = false

    if jbeamData.materialNameLeft and jbeamData.materialNameRight and jbeamData.geExtensionName then
        geExtensionName = jbeamData.geExtensionName
        glowMapEdit = true
        obj:queueGameEngineLua(
            " if not "..jbeamData.geExtensionName.." then extensions.load('".. jbeamData.geExtensionName .."') end "..
            " extensions."..jbeamData.geExtensionName..".initEmissionEdit('"..jbeamData.materialNameLeft.."', '"..jbeamData.materialNameRight.."')"
        )
        glowMapEditInit = true
    end
end

M.reset = init
M.init = init
M.updateGFX = updateGFX

return M